import peasy.*;

PeasyCam cam;

PVector pRay = new PVector(0, 0, 0);
PVector pRayDir = new PVector(0.8, .7, 1);

PVector boxCenter = new PVector(0, 60, 100);
float   boxW = 200;
float   boxH = 100;
float   boxD = 80;

PMatrix3D xform = new PMatrix3D();

void setup()
{
  // set the window size + 3d mode
  size(800, 600, P3D);

  // setup the camera
  cam = new PeasyCam(this, 1500);
  cam.setMinimumDistance(5);
  cam.setMaximumDistance(5000);
  perspective(radians(25), (float)width / (float)height, .1, 5000);
  
  xform.rotate(radians(45),0,1,0);
}

void draw()
{
  background(0);

  coordSys(100);

  // draw sphere
  fill(255);
  stroke(100);
  pushMatrix();
    applyMatrix(xform);
    translate(boxCenter.x,boxCenter.y,boxCenter.z);
   box(boxW,boxH,boxD);
  popMatrix();
   
  // draw ray
  stroke(255, 255, 0);
  drawRay(pRay,pRayDir);

  // check if the ray hits the triangle
  PVector hit1 = new PVector();
  PVector hit2 = new PVector();
                   
  if(boxIntersection(xform,
                     pRay,
                     pRayDir,
                     boxCenter,
                     boxW,
                     boxH,
                     boxD,
                     hit1,hit2) > 0)
  {
    strokeWeight(15);
    stroke(255, 0, 0);
    point(hit1.x, hit1.y, hit1.z);
    point(hit2.x, hit2.y, hit2.z);
    strokeWeight(1);
  }
  
}


